hdu 5025 Saving Tang Monk(bfs+状态压缩)
Description
《Journey to the West》(also 《Monkey》) is one of the Four Great Classical Novels of Chinese literature. It was written by Wu Cheng'en during the Ming Dynasty. In this novel, Monkey King Sun Wukong, pig Zhu Bajie and Sha Wujing, escorted Tang Monk to India to get sacred Buddhism texts.
During the journey, Tang Monk was often captured by demons. Most of demons wanted to eat Tang Monk to achieve immortality, but some female demons just wanted to marry him because he was handsome. So, fighting demons and saving Monk Tang is the major job for Sun Wukong to do.
Once, Tang Monk was captured by the demon White Bones. White Bones lived in a palace and she cuffed Tang Monk in a room. Sun Wukong managed to get into the palace. But to rescue Tang Monk, Sun Wukong might need to get some keys and kill some snakes in his way.
The palace can be described as a matrix of characters. Each character stands for a room. In the matrix, 'K' represents the original position of Sun Wukong, 'T' represents the location of Tang Monk and 'S' stands for a room with a snake in it. Please note that there are only one 'K' and one 'T', and at most five snakes in the palace. And, '.' means a clear room as well '#' means a deadly room which Sun Wukong couldn't get in.
There may be some keys of different kinds scattered in the rooms, but there is at most one key in one room. There are at most 9 kinds of keys. A room with a key in it is represented by a digit(from '1' to '9'). For example, '1' means a room with a first kind key, '2' means a room with a second kind key, '3' means a room with a third kind key... etc. To save Tang Monk, Sun Wukong must get ALL kinds of keys(in other words, at least one key for each kind).
For each step, Sun Wukong could move to the adjacent rooms(except deadly rooms) in 4 directions(north, west, south and east), and each step took him one minute. If he entered a room in which a living snake stayed, he must kill the snake. Killing a snake also took one minute. If Sun Wukong entered a room where there is a key of kind N, Sun would get that key if and only if he had already got keys of kind 1,kind 2 ... and kind N-1. In other words, Sun Wukong must get a key of kind N before he could get a key of kind N+1 (N>=1). If Sun Wukong got all keys he needed and entered the room in which Tang Monk was cuffed, the rescue mission is completed. If Sun Wukong didn't get enough keys, he still could pass through Tang Monk's room. Since Sun Wukong was a impatient monkey, he wanted to save Tang Monk as quickly as possible. Please figure out the minimum time Sun Wukong needed to rescue Tang Monk.
During the journey, Tang Monk was often captured by demons. Most of demons wanted to eat Tang Monk to achieve immortality, but some female demons just wanted to marry him because he was handsome. So, fighting demons and saving Monk Tang is the major job for Sun Wukong to do.
Once, Tang Monk was captured by the demon White Bones. White Bones lived in a palace and she cuffed Tang Monk in a room. Sun Wukong managed to get into the palace. But to rescue Tang Monk, Sun Wukong might need to get some keys and kill some snakes in his way.
The palace can be described as a matrix of characters. Each character stands for a room. In the matrix, 'K' represents the original position of Sun Wukong, 'T' represents the location of Tang Monk and 'S' stands for a room with a snake in it. Please note that there are only one 'K' and one 'T', and at most five snakes in the palace. And, '.' means a clear room as well '#' means a deadly room which Sun Wukong couldn't get in.
There may be some keys of different kinds scattered in the rooms, but there is at most one key in one room. There are at most 9 kinds of keys. A room with a key in it is represented by a digit(from '1' to '9'). For example, '1' means a room with a first kind key, '2' means a room with a second kind key, '3' means a room with a third kind key... etc. To save Tang Monk, Sun Wukong must get ALL kinds of keys(in other words, at least one key for each kind).
For each step, Sun Wukong could move to the adjacent rooms(except deadly rooms) in 4 directions(north, west, south and east), and each step took him one minute. If he entered a room in which a living snake stayed, he must kill the snake. Killing a snake also took one minute. If Sun Wukong entered a room where there is a key of kind N, Sun would get that key if and only if he had already got keys of kind 1,kind 2 ... and kind N-1. In other words, Sun Wukong must get a key of kind N before he could get a key of kind N+1 (N>=1). If Sun Wukong got all keys he needed and entered the room in which Tang Monk was cuffed, the rescue mission is completed. If Sun Wukong didn't get enough keys, he still could pass through Tang Monk's room. Since Sun Wukong was a impatient monkey, he wanted to save Tang Monk as quickly as possible. Please figure out the minimum time Sun Wukong needed to rescue Tang Monk.
Input
There are several test cases.
For each case, the first line includes two integers N and M(0 < N <= 100, 0<=M<=9), meaning that the palace is a N×N matrix and Sun Wukong needed M kinds of keys(kind 1, kind 2, ... kind M).
Then the N × N matrix follows.
The input ends with N = 0 and M = 0.
For each case, the first line includes two integers N and M(0 < N <= 100, 0<=M<=9), meaning that the palace is a N×N matrix and Sun Wukong needed M kinds of keys(kind 1, kind 2, ... kind M).
Then the N × N matrix follows.
The input ends with N = 0 and M = 0.
Output
For each test case, print the minimum time (in minutes) Sun Wukong needed to save Tang Monk. If it's impossible for Sun Wukong to complete the mission, print "impossible"(no quotes).
Sample Input
3 1
K.S
##1
1#T
3 1
K#T
.S#
1#.
3 2
K#T
.S.
21.
0 0
Sample Output
5
impossible
8
题意:K是起点,T是终点S是蛇,#是墙.是路,1-9是钥匙,要收集齐所有的钥匙,才能救出T(收集不全的时候你可以经过T房间)问最短时间
题解:用snack记录蛇是否被杀死,key记录收集到前多少把钥匙,
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 | #include<stdio.h> #include<string.h> #include<vector> #include<map> #include<queue> #include<stack> #include<cstdio> #include<string> #include<math.h> #include<algorithm> #define LL long long #define PI atan(1.0)*4 #define DD double #define MAX 101 #define mod 10003 #define dian 1.000000011 #define INF 0x3f3f3f using namespace std; int head[MAX],ans; int n,m,t; char s[MAX][MAX]; int vis[MAX][MAX][20][1<<6]; int ke[15]; struct node { int x,y,key,time,snack; friend bool operator < (node a,node b) { return a.time>b.time; } }; int Move[4][2]={1,0,-1,0,0,1,0,-1}; int judge( int a, int b) { if (a>=0&&a<n&&b>=0&&b<n&&s[a][b]!= '#' ) return 1; return 0; } int bfs( int x1, int y1) { int i; priority_queue<node>q; memset(vis,0, sizeof (vis)); while (!q.empty()) q.pop(); node beg,end; beg.x=x1; beg.y=y1; beg.time=0; beg.key=0; beg.snack=0; q.push(beg); vis[beg.x][beg.y][beg.key][beg.snack]=1; while (!q.empty()) { beg=q.top(); q.pop(); if (s[beg.x][beg.y]== 'T' &&beg.key==m) { ans=beg.time; return 1; } for (i=0;i<4;i++) { end.x=beg.x+Move[i][0]; end.y=beg.y+Move[i][1]; if (judge(end.x,end.y)) { if (s[end.x][end.y]>= 'a' &&s[end.x][end.y]<= 'z' ) //找到蛇 { end.snack=beg.snack; end.key=beg.key; int num=s[end.x][end.y]- 'a' ; if (end.snack&(1<<num)) //判断蛇是否被杀死 end.time=beg.time+1; else end.time=beg.time+2; end.snack|=(1<<num); //将这条蛇加入已杀死的标记 } else if (s[end.x][end.y]>= '1' &&s[end.x][end.y]<= '9' ) //找到钥匙 { end.snack=beg.snack; end.key=beg.key; end.time=beg.time+1; int num=s[end.x][end.y]- '0' ; if (end.key+1==num) //判断是否找到了n之前的钥匙 end.key++; } else //路 { end.key=beg.key; end.snack=beg.snack; end.time=beg.time+1; } if (!vis[end.x][end.y][end.key][end.snack]) //判断当前位置是否标记 { vis[end.x][end.y][end.key][end.snack]=1; q.push(end); } } } } return 0; } int main() { int x1,y1,i,j,k; while (scanf( "%d%d" ,&n,&m),n|m) { ans=0; for (i=0;i<n;i++) scanf( "%s" ,s[i]); k=0; for (i=0;i<n;i++) { for (j=0;j<n;j++) { if (s[i][j]== 'K' ) { x1=i;y1=j; } if (s[i][j]== 'S' ) { s[i][j]= 'a' +k++; //将不同的蛇标记出来 } } } if (bfs(x1,y1)) printf( "%d\n" ,ans); else printf( "impossible\n" ); } return 0; } |
【推荐】还在用 ECharts 开发大屏?试试这款永久免费的开源 BI 工具!
【推荐】国内首个AI IDE,深度理解中文开发场景,立即下载体验Trae
【推荐】编程新体验,更懂你的AI,立即体验豆包MarsCode编程助手
【推荐】轻量又高性能的 SSH 工具 IShell:AI 加持,快人一步